/*

Lecture 25: ArrayLists
July 31, 2019
Sam Vinitsky

*/

import java.util.ArrayList;

public class ArrayListsLecture{
    public static void main(String[] args){

        ////////////////
        // MOTIVATION //
        ////////////////

        // Give an example here

        //////////////
        // BIG IDEA //
        //////////////

        // ArrayList = dynamic array
        // Size CAN change!

        // Can only contain REFERENCE types
        // Wrappers Okay: Integer, Double, Boolean, Character

        //////////////////////////
        // DECLARING ARRAYLISTS //
        //////////////////////////

        // the "type" is ArrayList<Type>
        // ArrayList<String> list;
        // ArrayList<Integer> list2;
        // ArrayList<Double> list3;
        // ArrayList<Simple> list4;

        /////////////////////////////
        // CREATING NEW ARRAYLISTS //
        /////////////////////////////

        // // declare
        // ArrayList<String> list;
        // // create
        // list = new ArrayList<String>();
        

        // // declare + create
        // ArrayList<Integer> list2 = new ArrayList<Integer>();

        ////////////
        // LENGTH //
        ////////////

        // we didn't set a size
        // how long is the array by default?
        // ArrayList<String> list = new ArrayList<String>();
        // System.out.println(   list.size()  );

        /////////////////////
        // ADDING ELEMENTS //
        /////////////////////

        // // arrayName.add(element)
        // ArrayList<String> list = new ArrayList<String>();

        // list.add("My");
        // list.add("name");
        // list.add("is");
        // list.add("Sam");
        // System.out.println(list);

        // list.add("Goodbye");
        // System.out.println(list);

        // // .add(index, element)
        // list.add(0, "Hello");
        // System.out.println(list);

        // list.add(4, "not");
        // System.out.println(list);


        // list.add(100, "I'm far away");
        // System.out.println(list);


        // // Adding new objects?
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // // option 1
        // Simple s = new Simple();
        // s.x = 11;
        // list.add(s);
        // System.out.println(list);




        // // // option 2
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // list.add(new Simple());
        // list.add(new Simple(11));
        // System.out.println(list);


        // // wrapping primitives?
        // ArrayList<Integer> list2 = new ArrayList<Integer>();
        // list2.add(5);
        // list2.add(0);
        // list2.add(-2);
        
        // System.out.println(list2);
        //
        // list2.add(0, 11);
        // System.out.println(list2);

        // // EXAMPLE: What gets printed out?
        // ArrayList<Double> list = new ArrayList<Double>();
        // list.add(5.0);
        // list.add(0, 2.1);
        // list.add(6.5);
        // list.add(1, -12.2);
        // list.add(1, 0.3);
        
        // System.out.println(list);



        //////////////////////
        // GETTING ELEMENTS //
        //////////////////////

        // arrayName.get(index)
        // ArrayList<String> list = new ArrayList<String>();
        // list.add("My");
        // list.add("name");
        // list.add("is");
        // list.add("Sam");
        // list.add("Goodbye");
        
        // String s = list.get(5);
        // System.out.println(s);
        //


        // ArrayList<Simple> list = new ArrayList<Simple>();
        
        // list.add(new Simple(1));
        // System.out.println(list);
        
        // Simple s = list.get(0);
        // s.x = 5555;
        // System.out.println(list);

        ///

        // ArrayList<String> list = new ArrayList<String>();
        
        // list.add("Hello");
        // System.out.println(list);
        
        // String s = list.get(0);
        // s = new String("Woah");
        // System.out.println(list);

        // ArrayList<Double> list = new ArrayList<Double>();
        
        // list.add(5.5);
        // System.out.println(list);
        
        // Double s = list.get(0);
        // s = 11.2;
        // System.out.println(list);






        // // // EXAMPLE (you)
        // ArrayList<Simple> list = new ArrayList<Simple>();
        
        // list.add(new Simple(5));
        // Simple s = new Simple(11);


        // // System.out.println(list);

        // list.add(s);
        // // System.out.println(list);

        // list.add(list.get(1));
        // // System.out.println(list);
        
        // s.x = -1;
        // System.out.println(list);

        ///////////////////////
        // CHANGING ELEMENTS //
        ///////////////////////

        // .set(index, element)
        // ArrayList<String> list = new ArrayList<String>();
        // list.add("Hello");
        // list.add("Daniel"); 
        // System.out.println(list);
        
        // list.set(1, "Sam");
        // System.out.println(list);
        
        // list.set(0, "Goodbye");
        // System.out.println(list);

        // EXAMPLE
        // ArrayList<Simple> list = new ArrayList<Simple>();
        // list.add(new Simple());
        // list.add(new Simple(10));
        // list.add(list.get(0));
        
        // list.get(0).x = 5;
        
        // System.out.println(list);
        
        // list.set(0, new Simple());
        // System.out.println(list);

    }
}
